/****************************************************************************************
*  YAROCK                                                                               *
*  Copyright (c) 2010-2013 Sebastien amardeilh <sebastien.amardeilh+yarock@gmail.com>   *
*                                                                                       *
*  This program is free software; you can redistribute it and/or modify it under        *
*  the terms of the GNU General Public License as published by the Free Software        *
*  Foundation; either version 2 of the License, or (at your option) any later           *
*  version.                                                                             *
*                                                                                       *
*  This program is distributed in the hope that it will be useful, but WITHOUT ANY      *
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A      *
*  PARTICULAR PURPOSE. See the GNU General Public License for more details.             *
*                                                                                       *
*  You should have received a copy of the GNU General Public License along with         *
*  this program.  If not, see <http://www.gnu.org/licenses/>.                           *
*****************************************************************************************/

#ifndef _VIRTUAL_PLAYLIST_H_
#define _VIRTUAL_PLAYLIST_H_

#include <QObject>
#include <QStringList>
#include <QList>
#include <QString>

#include "MediaItem/mediaitem.h"

/*
********************************************************************************
*                                                                              *
*    Class VirtualPlayqueue                                                    *
*                                                                              *
********************************************************************************
*/
class VirtualPlayqueue : public QObject
{
static VirtualPlayqueue* INSTANCE;

Q_OBJECT
  public:
    VirtualPlayqueue(QWidget *parent=0);
    static VirtualPlayqueue* instance() { return INSTANCE; }
  
    void appendMedia(const MEDIA::TrackPtr media);
    void appendMedias(QList<MEDIA::TrackPtr> list, int startIdx);

    void clear();

    MEDIA::TrackPtr getRequestedMedia();
    MEDIA::TrackPtr getNextMediaItem();
    MEDIA::TrackPtr getPrevMediaItem();

    void    stopPlaying();
    void    updatePlayingItem(MEDIA::TrackPtr);

  private :
    QList<MEDIA::TrackPtr> unplayedMedia();
    void setRequestedMedia(int idx);

  private :
    enum RepeatMode {RepeatOff = 0,RepeatTrack = 1, RepeatAll = 2 };
    enum ShuffleMode {ShuffleOff = 0 ,ShuffleOn = 1};

    QList<MEDIA::TrackPtr>    m_tracks;
    MEDIA::TrackPtr           m_requested_track;
    MEDIA::TrackPtr           m_playing_track;

  signals :
    void signal_collection_playTrack();
};

#endif // _VIRTUAL_PLAYLIST_H_
